package net.carbon.controller;

import net.carbon.bean.PageResponse;
import net.carbon.model.request.TimelyWarningRequest;
import net.carbon.model.vo.TimelyWarningVO;
import net.carbon.result.Result;
import net.carbon.service.TimelyWarningService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
public class TimelyWarningController {

    @Autowired
    private TimelyWarningService timelyWarningService;

    @GetMapping("/api/TimelyWarning")
    public Result<PageResponse<TimelyWarningVO>> get(@RequestParam("pageSize") Long pageSize, @RequestParam("page") Long page) {
        return Result.success(timelyWarningService.getList(pageSize, page));
    }

    @DeleteMapping("/api/warn/delete")
    public Result<Boolean> delete(@RequestParam("id") Long id) {
        int row = timelyWarningService.delete(id);
        if (row > 0) {
            return Result.success();
        }
        return Result.error("删除失败");
    }

    @PostMapping("/api/warn/edit")
    public Result update(@RequestBody TimelyWarningRequest timelyWarningRequest) {
        int row = timelyWarningService.updateById(timelyWarningRequest);
        if (row > 0) {
            return Result.success();
        }
        return Result.error("修改失败");
    }

    @PostMapping("/api/warn/add")
    public Result add(@RequestBody TimelyWarningRequest timelyWarningRequest) {
        timelyWarningService.add(timelyWarningRequest);
        return Result.success();
    }
}
