package net.carbon.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import net.carbon.mapper.CarbonEmissionMapper;
import net.carbon.model.po.CarbonEmissionDO;
import net.carbon.service.CarbonEmissionService;


import net.carbon.vo.CarbonTimelyAlertVO;
import net.carbon.vo.CarbonVO;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author jieyuu
 * @since 2024-12-29
 */
@Service
public class CarbonEmissionServiceImpl extends ServiceImpl<CarbonEmissionMapper, CarbonEmissionDO> implements CarbonEmissionService {

    @Autowired
    private CarbonEmissionMapper carbonEmissionMapper;

    @Override
    public CarbonTimelyAlertVO timelyAlert(String city) {
        if (city == null || StringUtils.isBlank(city)) {
            return null;
        }
        QueryWrapper<CarbonEmissionDO> queryWrapper = new QueryWrapper<>();
        queryWrapper.like("city", city);

        CarbonEmissionDO carbonEmissionDO = carbonEmissionMapper.selectOne(queryWrapper);

        CarbonTimelyAlertVO result = new CarbonTimelyAlertVO();
        if (carbonEmissionDO == null) {
            return null;
        }
        BeanUtils.copyProperties(carbonEmissionDO, result);

        return result;
    }

    @Override
    public CarbonVO getCarbonEmissionData(String city) {
        if (city == null || StringUtils.isBlank(city)) {
            return null;
        }
        QueryWrapper<CarbonEmissionDO> queryWrapper = new QueryWrapper<>();
        queryWrapper.like("city", city);

        CarbonEmissionDO carbonEmissionDO = carbonEmissionMapper.selectOne(queryWrapper);

        CarbonVO result = new CarbonVO();
        if (carbonEmissionDO == null) {
            return null;
        }
        BeanUtils.copyProperties(carbonEmissionDO, result);

        return result;
    }
}
