package net.carbon.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import net.carbon.bean.PageResponse;
import net.carbon.mapper.TimelyWarningMapper;
import net.carbon.model.po.TimelyWarningDO;
import net.carbon.model.request.TimelyWarningRequest;
import net.carbon.model.vo.TimelyWarningVO;
import net.carbon.service.TimelyWarningService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@Service
public class TimelyWarningServiceImpl implements TimelyWarningService {

    @Autowired
    private TimelyWarningMapper timelyWarningMapper;
    @Override
    public PageResponse<TimelyWarningVO> getList(Long pageSize, Long page) {
        Page<TimelyWarningDO> pageInfo = new Page<>(page, pageSize);
        IPage<TimelyWarningDO> TimelyWarningDOPage = timelyWarningMapper.selectPage(pageInfo, new LambdaQueryWrapper<TimelyWarningDO>());

        PageResponse<TimelyWarningVO> pageResponse = new PageResponse<>();

        List<TimelyWarningVO> TimelyWarningVOS = TimelyWarningDOPage.getRecords().stream().map(obj -> {
            TimelyWarningVO timelyWarningVO = new TimelyWarningVO();
            BeanUtils.copyProperties(obj, timelyWarningVO);
            return timelyWarningVO;
        }).collect(Collectors.toList());

        pageResponse.setPageSize(TimelyWarningDOPage.getSize());
        pageResponse.setCurrent(TimelyWarningDOPage.getCurrent());
        pageResponse.setTotal(TimelyWarningDOPage.getTotal());
        pageResponse.setRecords(TimelyWarningVOS);
        return pageResponse;
    }

    @Override
    public int delete(Long id) {
        LambdaQueryWrapper<TimelyWarningDO> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(TimelyWarningDO::getId, id);
        return timelyWarningMapper.delete(queryWrapper);
    }

    @Override
    public int updateById(TimelyWarningRequest timelyWarningRequest) {
        TimelyWarningDO timelyWarningDO = new TimelyWarningDO();
        BeanUtils.copyProperties(timelyWarningRequest, timelyWarningDO);
        int row = timelyWarningMapper.updateById(timelyWarningDO);
        return row;
    }

    @Override
    public void add(TimelyWarningRequest timelyWarningRequest) {
        timelyWarningMapper.add(timelyWarningRequest);
    }
}
