package biz;

import com.baomidou.mybatisplus.annotation.DbType;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.generator.AutoGenerator;
import com.baomidou.mybatisplus.generator.FastAutoGenerator;
import com.baomidou.mybatisplus.generator.config.*;
import com.baomidou.mybatisplus.generator.config.rules.DateType;
import com.baomidou.mybatisplus.generator.config.rules.DbColumnType;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import com.baomidou.mybatisplus.generator.engine.FreemarkerTemplateEngine;

import java.nio.file.Paths;
import java.sql.Types;
import java.util.Collections;

public class MyBatisPlusGenerator {

    public static void main(String[] args) {
//        //1. 全局配置
//        GlobalConfig config = new GlobalConfig();
//        // 是否支持AR模式
//        config.setActiveRecord(true)
//                // 作者
//                .setAuthor("jieyuu")
//                // 生成路径，最好使用绝对路径，window路径是不一样的
//                .setOutputDir("D:\\workspace\\project\\CarbonNeutrality\\server\\src\\test\\temp")
//                // 文件覆盖
//                .setFileOverride(true)
//                // 主键策略
//                .setIdType(IdType.AUTO)
//
//                .setDateType(DateType.ONLY_DATE)
//                // 设置生成的service接口的名字的首字母是否为I，默认Service是以I开头的
//                .setServiceName("%sService")
//
//                //实体类结尾名称
//                .setEntityName("%sDO")
//
//                //生成基本的resultMap
//                .setBaseResultMap(true)
//
//                //不使用AR模式
//                .setActiveRecord(false)
//
//                //生成基本的SQL片段
//                .setBaseColumnList(true);
//
//        //2. 数据源配置
//        DataSourceConfig dsConfig = new DataSourceConfig();
//        // 设置数据库类型
//        dsConfig.setDbType(DbType.MYSQL)
//                .setDriverName("com.mysql.cj.jdbc.Driver")
//                .setUrl("jdbc:mysql://106.52.88.120:3306/demo?useSSL=false")
//                .setUsername("root")
//                .setPassword("59ae8683c59fead903132a8d440bd7d9fd4936529d1d6f45f9d41111d7537bdd");
//
//        //3. 策略配置globalConfiguration中
//        StrategyConfig stConfig = new StrategyConfig();
//
//        //全局大写命名
//        stConfig.setCapitalMode(true)
//                // 数据库表映射到实体的命名策略
//                .setNaming(NamingStrategy.underline_to_camel)
//
//                //使用lombok
//                .setEntityLombokModel(true)
//
//                //使用restcontroller注解
//                .setRestControllerStyle(true)
//
//                // 生成的表, 支持多表一起生成，以数组形式填写
//                .setInclude("label");
//
//        //4. 包名策略配置
//        PackageConfig pkConfig = new PackageConfig();
//        pkConfig.setParent("net.carbon")
//                .setMapper("mapper")
//                .setService("service")
//                .setController("controller")
//                .setEntity("model")
//                .setXml("mapper");
//
//        //5. 整合配置
//        AutoGenerator ag = new AutoGenerator();
//        ag.setGlobalConfig(config)
//                .setDataSource(dsConfig)
//                .setStrategy(stConfig)
//                .setPackageInfo(pkConfig);
//
//        //6. 执行操作
//        ag.execute();

        // 使用 FastAutoGenerator 快速配置代码生成器
        FastAutoGenerator.create("jdbc:mysql://106.52.88.120:3306/demo?useUnicode=true&characterEncoding=utf-8&useSSL=false&serverTimezone=Asia/Shanghai", "root", "59ae8683c59fead903132a8d440bd7d9fd4936529d1d6f45f9d41111d7537bdd")
                .globalConfig(builder -> {
                    builder.author("jieyuu") // 设置作者
                            .outputDir("D:\\workspace\\project\\CarbonNeutrality\\server\\src\\test\\java"); // 输出目录
                })
                .packageConfig(builder -> {
                    builder.parent("net.carbon") // 设置父包名
                            .entity("model") // 设置实体类包名
                            .controller("controller")
                            .mapper("mapper") // 设置 Mapper 接口包名
                            .service("service") // 设置 Service 接口包名
                            .serviceImpl("service.impl") // 设置 Service 实现类包名
                            .xml("mappers"); // 设置 Mapper XML 文件包名
                })
                .strategyConfig(builder -> {
                    builder.addInclude("user", "label" , "economics") // 设置需要生成的表名
                            .entityBuilder()
                            .enableLombok() // 启用 Lombok
                            .enableTableFieldAnnotation() // 启用字段注解
                            .controllerBuilder()
                            .enableRestStyle(); // 启用 REST 风格
                })
                .templateEngine(new FreemarkerTemplateEngine()) // 使用 Freemarker 模板引擎
                .execute(); // 执行生成

        System.out.println("=======  Done 相关代码生成完毕  ========");
    }
}